part of '../flutterx_live_data.dart';

/// Dispatcher for [LiveData] observers
/// Available dispatchers are:
/// [postFrame]
abstract class Dispatcher {
  /// Schedule action after end of frame
  static const Dispatcher postFrame = _PostFrameDispatcher();

  /// Dispatcher implementations also may be const
  const Dispatcher();

  /// Dispatch given [action] according to implementation context
  void post(VoidCallback action);
}

class _PostFrameDispatcher extends Dispatcher {
  const _PostFrameDispatcher();

  @override
  void post(VoidCallback action) => WidgetsBinding.instance!.endOfFrame.then((_) => action());
}
